/**
  Generated main.c file from MPLAB Code Configurator

  @Company
    Microchip Technology Inc.

  @File Name
    main.c

  @Summary
    This is the generated main.c using PIC24 / dsPIC33 / PIC32MM MCUs.

  @Description
    This source file provides main entry point for system initialization and application code development.
    Generation Information :
        Product Revision  :  PIC24 / dsPIC33 / PIC32MM MCUs - 1.167.0
        Device            :  PIC24FV32KA301
    The generated drivers are tested against the following:
        Compiler          :  XC16 v1.50
        MPLAB 	          :  MPLAB X v5.35
 * 
 * 
 * 
 *                  A6_V41calib_TIM1_U2TX_24FV32KA.X
 *                  Ώۊ́AuOCXO Calibrator V4vz
 * 
 * NbNTIMER1ŃJEgāAU2TX STM32(RX3)ɑB
 * STM32́ASTM_SSD1309_GPSFC_5V40
 *  
 * LCD ́AACeh́utI2CLN^LCDW[i16x2j [ATD1602CPB]v
 * QƂ́Aug݌nVXeJbyZMṽuOłB(2020/04/04)
 * 
 * ̕@ŁATIMER1͍ōg50MHzȏ܂ŐLтB
 * A̓x-10dBmx(50MHz)܂ŃJEgB
 * 
 * 2020/04/27:
 * PIC24FV32KA302(28pin) ==> PIC24FV32KA301(20pin)
 *  
 * 
*/

/*
    (c) 2020 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

/**
  Section: Included Files
 */

// delay֐ĝɕKvBNbNg2ߎsTCN
#define FCY 16000000  // NbNgFOSC(32MHz)2

#include "mcc_generated_files/system.h"

#include <libpic30.h> // __delay_ms()ɕKv
#include <stdio.h>      // sprintf()ɕKv
#include <string.h>     // strlen()ɕKv
#include <ctype.h>
#include "p24FV32KA301.h"   // ANSB TRISBbits. ɕKv
#include "i2c2.h"       // G[ômcc_generated_files/ړ
// ȉRpC͒ʂ邪xôŋLq
#include "tmr1.h"
#include "ext_int.h"
#include "uart2.h"

// =================================================

#define Reset() asm("reset")    // ZbgiAZu߁j̒`

#define I2CLCD_AQM0802A 0x3E   // 3FLCDł3EƋLq

// USrbg({x_^)w̌
//  project  properties  xc16gcc Ł@?Use64-bit doublew肵A
// ǁA{vOł͕_gpȂB

// ^C}[֘ÃO[oϐ ui64overf
uint64_t ui64overf = 0;
uint16_t ui16count = 0; // 
uint8_t countBusy = 0;
uint8_t CountOk = 0;

char outBuff[22];

char temptxt[80];

// xôŊ֐̃vg^Cv錾ȉɋLqB
//void TMR1_JOB(void);
//void ui64bitTOhex16(uint64_t , char* );

// LCD֌W  
//ug݌nVXeJbyZMṽuO

/**
 * R}h
 * @param device_address    FI2CfoCX̃AhX
 * @param controlByte   FRg[oCg
 * @param cmdData   FR}h
 * @return
 */
uint8_t I2C2_write(uint8_t device_address, uint8_t controlByte, uint8_t cmdData) {
    I2C2_MESSAGE_STATUS status = I2C2_MESSAGE_PENDING;
    uint8_t write_buffer[2];

    write_buffer[0] = controlByte;
    write_buffer[1] = cmdData;

    I2C2_MasterWrite(write_buffer, 2, device_address, &status);
    int cnt = 0;

    while (status == I2C2_MESSAGE_PENDING && cnt++ < 10) {
        __delay_us(100);
    }
    return (status == I2C2_MESSAGE_COMPLETE);
}

/**
 * LCD̎wAhXɕ\
 * @param str: \
 * @param numF\oCg
 * @param LcdAddr LCDDDRAM\AhX
 */
void WireLcdDisplay(char *str, int num, uint8_t LcdAddr) {
    uint8_t dt[65]; //16܂őΉ@64Ɋg
    int i;
    I2C2_MESSAGE_STATUS status = I2C2_MESSAGE_PENDING;

    // Set DDRAM address R}hZbg
    dt[0] = 0x40;

    // AXL[R[hɕϊĔzɊi[
    for (i = 0; i < num; i++) {
        dt[i + 1] = (uint8_t) str[i];
    }

    // Slave֐R[hF0x00
    // R}h:0x80 + DDRAM̃AhX
    I2C2_write(I2CLCD_AQM0802A, 0x00, 0x80 | LcdAddr);
    I2C2_MasterWrite(dt, num + 1, I2CLCD_AQM0802A, &status);
    int cnt = 0;

    while (status == I2C2_MESSAGE_PENDING && cnt++ < 10) {
        __delay_us(100);
    }
    __delay_ms(1); // ǉČĂяo(main)ɋLqȂB
}

// ɂďo͂f[^͈ȉ̒ʂɂȂ܂
// yI2C2_writeɂďo͂f[^z
// 0x7C@FLCD̃AhX
// 0x00@FRg[oCgiRS=0FR}hj̓R}h𑗂
// 0x80@FR}hoCgiSetDDRAMaddress + DDRAMAhXj
//
// yI2C2_MasterWriteɂďo͂f[^z
// 0x7C@FLCDAhX
// 0x40@FRg[oCg(RS=1Ff[^jf[^𑗂
// \f[^inumj

/**
 * LCD ̏@
 */
void WireLcdInit(void) {
    I2C2_MESSAGE_STATUS status = I2C2_MESSAGE_PENDING;
    uint8_t sendData[ ] = {0x38, 0x39, 0x14, 0x70, 0x56, 0x6C, 0x38, 0x0C, 0x01};

    I2C2_MasterWrite(sendData, sizeof (sendData) + 1, I2CLCD_AQM0802A, &status);
    int cnt = 0;

    while (status == I2C2_MESSAGE_PENDING && cnt++ < 10) {
        __delay_us(100);
    }
    __delay_ms(1); // ǉČĂяo(main)ɋLqȂB
}


// =================================================
// ǉ֐  jlb.jp
// \ʒuw肵 LCD ɕ\
// ll = s:0 or 1   ,cc :0 to 15
// =================================================

void WireLcd_lxc_Print(uint8_t ll, uint8_t cc, char* txt) {
    uint8_t ca, lc;
    int ln = strlen(txt);
    if (ln > 16) ln = 16;
    ca = cc;
    switch (ll) {
        case 1:
            lc = 0x40;
            break;
        default:
            lc = 0x00;
    }
    if (ca > 15) ca = 15;
    lc += ca;

    WireLcdDisplay(txt, ln, lc);
}

// =================================================
// ǉ֐  jlb.jp
// ʕ\N[
// 
// =================================================

void WireLcd_Clr(void) {
    char sptext[17] = "                ";
    WireLcdDisplay(sptext, 16, 0x00);
    WireLcdDisplay(sptext, 16, 0x40);
}

// ܂ł́ALCD֌W̋Lq 

// OM荞 

// =================================================
// INT0 ́A~RESETM(Low active)̂ŁA
// \߂lbb uNegativeEdgevw肵ĂB
// 
// 
// INT1 ́AO܂ ~GONMg [PositiveEdge]A
// V4.0́@GATEM(High active)ɕύXB
// GATEM̏I𔻒f̂ŁA\߁lbb
//uNegativeEdgevw肵ĂB(2020/04/10)
// =================================================

// =================================================
// ǉ֐  jlb.jp
// GATE(INT1)Ȍ݂֐
// GATEOFF ɁAB
// CountOk = 1 ZbgB
// ext_intc ɘAgB
// EXT_INT1  INT0 ́Qw肷 ext_int.c 
//  void __attribute__ ((weak)) EX_INT0_CallBack(void)
// {
//    // Add your custom callback code here
// }
// oBɋLqH
// ===========
// JE^[l̃N[INT0  INT2ɕύX
// INT0 ́APIC̃\tgZbgƂB(2020/04/12)
// =================================================

// INT1ŏ̂߁Asvij
void EX_INT2_CallBack(void) { // JE^[l̃N[MiLOWANeBuj
   // TMR1_Stop(); // ^C}[Xgbv
  //  TMR1_Counter16BitSet(0); // JE^[N[
  //  ui16count = 0;
  //  ui64overf = 0;
   // TMR1_Start(); // ^C}[X^[g
}


void EX_INT1_CallBack(void) { // GATEMOFFɌĂяoiLOWANeBuj
    // if (TRISBbits.TRISB14 == 0) { // Ô߃rbgmFB
    TMR1_Stop(); // ^C}[Xgbv
    CountOk = 1; // JEgtOON(1)
    ui16count = TMR1_Counter16BitGet(); // 16bit ǂݏoB
    ui64overf = ui64overf << 16; // I[o[t[16bitVtg
    ui64overf = ui64overf + ui16count; // vJEg
    TMR1_Counter16BitSet(0); // JE^[N[
    TMR1_Start(); // ^C}[X^[g

}

void EX_INT0_CallBack(void) { // PICZbgMiHIGHANeBuj̏

     Reset(); // ɃZbg
}
// ܂ŊOM荞 

// A^C}[ 

/*
 * ^C}[I[o[t[Ƃ̏֐
 * tmr1.c ɋLqB
 * 
 * void TMR1_CallBack(void);
 * void TMR1_JOB(void); // jlb MB
 * 
 * 
 * void __attribute__ ((weak)) TMR1_CallBack(void)
 * {
 *   // Add your custom callback code here
 *    TMR1_JOB(); // MB
 * }
 * ƉMB
 * ́@TMR1_JOB(); ɋLqB
 */
void TMR1_JOB(void) {
    ui64overf++; // I[o[t[JE^ {PB
}

// ܂ŁA^C}[ 


/*************************************************************
 * vꂽJEgvlivŹAEX_INT1_CallBack(void)@)
 * ɗL char outHex[] ̃tH[}bg[4bit]ɕϊB
 *          4bit ==> 1Byte  0x30 @OR  Hexɕϊ
 * 0x0 => '0', 0x1 => '1', 0xa => 'A', ,,, 0xf => 'F'   
 * 2̃`FbNT(Check Sum)tB(2020/04/10)
 * in64val  ==>    char outStr[21];
 *************************************************************/
void ui64bitTOhex16(uint64_t in64val, char * outHex) {
    int8_t i;
    uint8_t tmpB1;
    uint16_t sum16 = 0;
    outHex[0] = '['; // START Mark
    outHex[19] = ']'; // END Mark
        outHex[20] = 0x0; // 0x0
    for (i = 0; i < 16; i++) {
        tmpB1 = in64val & 0x0F;
        if (tmpB1 > 9) {
            tmpB1 += 55;
        } else {
            tmpB1 |= 0x30;
        }
        outHex[i + 1] = tmpB1;
        sum16 += tmpB1;
        in64val = in64val >> 4;
    }
    for (i = 0; i < 2; i++) { // `FbNSUM
        tmpB1 = sum16 & 0x0F;
        if (tmpB1 > 9) {
            tmpB1 += 55;
        } else {
            tmpB1 |= 0x30;
        }
        outHex[i + 17] = tmpB1;
        sum16 >>= 4;
    }
}

/*************************************************************
 * ɗL char outHex[] ̃tH[}bg
 * VAM邽߂̕ϊ
 *  char outHex[];  ==>   U2TX
 *************************************************************/
void Serialwrite(char *outHex) {
    int8_t i,j;
    uint8_t uwd;
    j = strlen(outHex);
    for (i = 0; i < j; i++) {
        uwd = outHex[i];
        UART2_Write(uwd);
    }
}

/*
      Main application  
 */
int main(void) {
    uint8_t DisplayON = 0; // 0 = LCD OFF,   1 = LCD ON
    // initialize the device
    SYSTEM_Initialize(); // O EXT_INT̏ ^C}[܂
    __delay_ms(1); // Ô

    // lbb TMR1 ==> Registers ==> uRegister:PR1vŐݒ
    // TMR1_Period16BitSet(0xFFFF); // TIMER1(16bit)p

    TMR1_Start(); //^C}[X^[g

    if (DisplayON == 1) {
        WireLcdInit(); // LCD
        WireLcd_lxc_Print(0, 0, "A6 TIMER 1");
        WireLcd_lxc_Print(1, 1, "2020/04/27 ");
        __delay_ms(1); // 1mSec҂ł (CountOk == 1) ܂ŏL\ێ

    }

    while (1) {

        if (CountOk == 1) {

            // JEg̑M
            ui64bitTOhex16(ui64overf, outBuff);
            Serialwrite(outBuff);

            if (DisplayON == 1) {
                // LCD ւ̕\
                WireLcd_Clr(); // ʕ\N[
                WireLcd_lxc_Print(0, 0, "PIC24KA301_TMR1");
                sprintf(temptxt, "%13lld", ui64overf); // %lld tlong long OK
                strcat(temptxt, "/G");
                WireLcd_lxc_Print(1, 0, temptxt); // 2sڂ4ڂ\

            }

            // ڎmFpLED
            if (LATAbits.LATA3 == 0) {
                LATAbits.LATA3 = 1; // LED off (high)
            } else {
                LATAbits.LATA3 = 0; // LED on (low)
            }


            ui64overf = 0;
            CountOk = 0; // JEgԂN[
        }

    }
    return 1;
}

/**
 End of File
 */

